## R-1.8.1.tgz

=== DESCRIPTION ===
Bundle: VR
Priority: recommended
Contains: MASS class nnet spatial
Version: 7.1-11
Date: 2003-10-21
Depends: R (>= 1.8.0), lattice, nlme (>= 3.1-40), survival
Author: S original by Venables & Ripley.
  R port by Brian Ripley <ripley@stats.ox.ac.uk>, following earlier
  work by Kurt Hornik and Albrecht Gebhardt.
Maintainer: Brian Ripley <ripley@stats.ox.ac.uk>
BundleDescription: Functions and datasets to support Venables and
  Ripley, 'Modern Applied Statistics with S' (4th edition).
License: GPL (version 2 or later)
URL: http://www.stats.ox.ac.uk/pub/MASS4/

=== src/gnuwin32/Makefile ===
include MkRules
include ../../share/make/vars.mk

## This is done so Rpwd.exe gets built first under a native build,
## but it is not used in Makefile under a cross-build.
ifneq ($(strip $(BUILD)),CROSS)
ifneq ($(strip $(wildcard Rpwd.exe)),)
all: Rpwd.exe rbuild rpackage rdocs
else
all: Rpwd.exe
	$(MAKE) rbuild rpackage rdocs
endif
else
all: Rpwd.exe rbuild rpackage rdocs
endif

## must be absolute and space-free paths
ifneq ($(strip $(BUILD)),CROSS)
RHOME = $(shell ./Rpwd.exe ../..)
PKGD = $(shell ./Rpwd.exe $(PKGDIR))
else
RHOME = $(shell perl pwd.pl ../..)
PKGD = $(shell perl pwd.pl $(PKGDIR))
endif

RPREFIX = $(shell perl fixed/rwver.pl ../../VERSION)

PACKAGES = $(filter-out tcltk, $(R_PKGS_BASE))

RLIB = $(RHOME)/library
PKGDIR = $(RHOME)/src/library

OPTFLAGS=-O2 -Wall -pedantic
## use FOPTFLAGS where complex*16 is used.
FOPTFLAGS=-O2 -Wall
ifdef DEBUG
 OPTFLAGS+=-g
 FOPTFLAGS+=-g
 DLLFLAGS=
else
 DLLFLAGS=-s
endif

ifneq ($(strip $(BUILD)),CROSS)
R-DLLFLAGS = -mwindows
## needed for gcc-3.2.2 but not 3.2 nor 3.2.3
## R-DLLFLAGS = -mwindows -Wl,--allow-multiple-definition
else
R-DLLFLAGS = -mwindows
endif
R-DLLLIBS =-L. $(FLIBS) -lRblas -lcomctl32 -lversion
SOURCES = $(filter-out malloc.c blas00.c,$(wildcard *.c *.f))
OBJS = $(SOURCES:.c=.o)
MAINLIBS = libmain.a libappl.a libmath.a
EXTRALIBS = ga.a gl.a xdr.a ../extra/zlib/libz.a ../extra/pcre/libRpcre.a\
   ../extra/bzip2/libbz2.a

LIBFILES = $(foreach i, $(R_PKGS_BASE), ../../library/$i) ../../library/R.css
PKGS = $(foreach i,$(PACKAGES),pkg-$i)
PKGCLEAN = $(foreach i,$(R_PKGS_BASE),pkgclean-$i)

# flags to ensure that Doug Lea's malloc is used:
ifdef LEA_MALLOC
extra-CFLAGS+=-DLEA_MALLOC
OBJS-EXTRA=malloc.o
endif

.PHONY:  clean veryclean  rlibs fixfiles front-ends rmodules


# separate as Tcl/Tk headers are needed.
tcl:
	@$(MAKE) --no-print-directory pkg-tcltk

CFLAGS = $(OPTFLAGS) -I../include -I. -DHAVE_CONFIG_H -DR_DLL_BUILD
FFLAGS = $(FOPTFLAGS)

Rpwd.exe: front-ends/Rpwd.exe
	$(CP) $< $@

front-ends/Rpwd.exe:
	$(MAKE) --no-print-directory -C front-ends Rpwd

## watch out: R.dll and Rblas.dll depend on each other.
rbuild: fixfiles rlibs makeMakedeps libRblas.a ../../bin/R.dll libR.a \
	 ../../bin/Rblas.dll CHTML front-ends COPYRIGHTS rmodules Rcode

## used to build skeletal versions of packages, enough to run
## package tools to install them properly
INITPACKAGES = base tools
Rcode: fixed/fixdesc
	@$(ECHO) "  making bootstrap versions of packages ..."
	@for pkg in $(INITPACKAGES); do \
	  if ! test -f $(RHOME)/library/$${pkg}/DESCRIPTION ; then \
	  $(ECHO) "  --" $$pkg; \
	  $(MAKE) --no-print-directory -C $(PKGDIR)/$${pkg} PKG=$${pkg} \
	    RHOME=$(RHOME) -f $(RHOME)/src/gnuwin32/MakePkg BUILD=$(BUILD) Rcode; \
	  fi; \
	done
	@$(ECHO) "  ... done"


rpackage: ../../library/R.css
	@$(MAKE) --no-print-directory $(PKGS)

rlibs:
	$(MAKE) --no-print-directory -C ../appl  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) --no-print-directory -C ../main  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) --no-print-directory -C ../nmath OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) --no-print-directory -C ./graphapp
	$(MAKE) --no-print-directory -C ./getline
	$(MAKE) --no-print-directory -C ../extra/xdr -f Makefile.win

rmodules: libRm.a
	$(MAKE) --no-print-directory -C ../modules \
	  OPTFLAGS='$(OPTFLAGS)' FOPTFLAGS='$(FOPTFLAGS)' -f Makefile.win

COPYRIGHTS: $(RHOME)/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles: docfiles
	@$(MKDIR) -p ../../bin
	@$(MAKE) --no-print-directory -C ./fixed

fixed/fixdesc:
	@sh fixed/GETDESC $(R_PKGS_BASE)

dllversion.o: ../include/Rversion.h

R.dll: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) dllversion.o

Rdll: makeMakedeps libRblas.a ../../bin/R.dll

../../bin/R.dll: fixfiles rlibs R.dll
	@$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/

front-ends: libR.a
	$(MAKE) --no-print-directory -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	$(AR) cr R.a $^
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

R.exp: R.exp1
	@(diff R.exp R.exp1 > /dev/null) || $(CP) R.exp1 R.exp

R.exp1: R.a $(MAINLIBS) $(EXTRALIBS) exported-vars
	@$(ECHO) EXPORTS > $@
	@$(NM) R.a $(MAINLIBS) $(EXTRALIBS) > RDefs
	@$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	@$(CAT) exported-vars >> $@
	@$(RM) RDefs

# An additional import library needed for the modules that uses R.dll's malloc/.../free
libRm.a:  Rm.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def Rm.exp --output-lib libRm.a

Rm.exp: Rm.exp1
	@(diff Rm.exp Rm.exp1 > /dev/null) || $(CP) Rm.exp1 Rm.exp

Rm.exp1: $(OBJS-EXTRA)
	@$(ECHO) EXPORTS > $@
	@$(NM) $(OBJS-EXTRA) > RDefs
	@$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	@$(RM) RDefs

../../library/R.css: ../../doc/html/R.css
	$(CP) $< $@

../extra/zlib/libz.a:
	$(MAKE) --no-print-directory -C ../extra/zlib -f Makefile.win

../extra/pcre/libRpcre.a:
	$(MAKE) --no-print-directory -C ../extra/pcre -f Makefile.win

../extra/bzip2/libbz2.a:
	$(MAKE) --no-print-directory -C ../extra/bzip2  -f Makefile.win libbz2.a

rdocs:
	@$(ECHO)
	@$(ECHO) "------ Making HTML documentation ------"
	@$(MAKE) --no-print-directory -C ../../doc/manual -f Makefile.win html BUILD=$(BUILD)


#                          ===== BLAS ======

Rblas: ../../bin/Rblas.dll

Rblas-clean:
	$(RM) ../../bin/Rblas.dll blas00.o blas00.d blas.o cmplxblas.o

Rblas-DLLLIBS=-L. -lR

libRblas.a:  Rblas.def
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname Rblas.dll \
	  --def Rblas.def --output-lib libRblas.a

ifeq ($(strip $(USE_ATLAS)),YES)
../../bin/Rblas.dll: blas00.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared $(DLLFLAGS) -o $@ $^ Rblas.def -L $(ATLAS_PATH) \
	   -L. -lR -lg2c -lf77blas -latlas
## suppress lots of warnings: this is a dummy
blas00.o: blas00.c
	$(CC) -O2  -c $< -o $@
else
../../bin/Rblas.dll: blas.o cmplxblas.o zgemm.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared $(DLLFLAGS) -o $@ Rblas.def $^ -L. -lR

blas.o: ../appl/blas.f
	$(F77) $(FFLAGS) -c $< -o $@
zgemm.o: ../appl/zgemm.f
	$(F77) $(FOPTFLAGS) -c $< -o $@
cmplxblas.o: ../modules/lapack/cmplxblas.f
	$(F77) $(FOPTFLAGS) -c $< -o $@
endif


#                          ===== Packages ======

CHTML:
ifeq ($(strip $(HELP)),YES)
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) --no-print-directory -C ./help -f MkChmDll
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) --no-print-directory -C ./help -f MkChmDll
endif
endif

base-HELP = ziponly
methods-HELP = ziponly
nls-HELP = ziponly
ts-HELP = ziponly
base-ZIPDATA = zip
ts-ZIPDATA = zip

MASS-HELP = ziponly
MASS-ZIPDATA = zip
boot-HELP = ziponly
boot-ZIPDATA = zip
cluster-HELP = ziponly
cluster-ZIPDATA = zip
grid-HELP = ziponly
grid-ZIPDATA = zip
lattice-HELP = ziponly
lattice-ZIPDATA = zip
nlme-HELP = ziponly
nlme-ZIPDATA = zip
rpart-HELP = ziponly
rpart-ZIPDATA = zip
survival-HELP = ziponly
survival-ZIPDATA = zip

# need special-case handling for bundle, as --auto-zip is not enabled
dse1-HELP = ziponly
dse2-HELP = ziponly

bundle-%:
	@$(PERL) fixed/dobundle.pl $* $(PKGD) $(RLIB)

pkg-%:
	@$(MAKE) --no-print-directory DLLNM=$($*-DLLNM)  FLIBS="$(FLIBS)" BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) RVER=$(RVER) \
	  -f $(RHOME)/src/gnuwin32/MakePkg
	@if test -d $(RLIB)/$*/data ; then \
	  $(MAKE) --no-print-directory $($*-ZIPDATA)data-$* ; \
	fi
ifeq ($(strip $(HELP)),YES)
	@$(ECHO) "  installing help"
	@$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) $($*-HELP)help-$*
ifeq ($(strip $(WINHELP)),CHM)
	@$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) chm-$*
endif
ifeq ($(strip $(WINHELP)),BOTH)
	@$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) winhlp-$* # also makes chm
endif
endif
	@$(MAKE) --no-print-directory BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB)  \
	  -f $(RHOME)/src/gnuwin32/MakePkg md5sums

pkgfake-%:
	@$(MAKE) --no-print-directory DLLNM=$($*-DLLNM)  FLIBS="$(FLIBS)" BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) RVER=$(RVER) \
	  -f $(RHOME)/src/gnuwin32/MakePkg fake
	@$(ECHO) "  installing help"
	@$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) pkgfake-$*


pkgclean-%:
	$(MAKE) --no-print-directory DLLNM=$($*-DLLNM) RHOME=$(RHOME) BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* -f $(RHOME)/src/gnuwin32/MakePkg clean

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@$(MKDIR) -p $(PKGDIR)/$*/check
	@$(MAKE) --no-print-directory -C $(PKGDIR)/$*/check PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/check/PkgCheck
	@if test -d $(PKGDIR)/$*/tests ; then \
	  $(MAKE) --no-print-directory -C $(PKGDIR)/$*/tests PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	    -f $(RHOME)/src/gnuwin32/check/PkgCheck tests;\
	fi

ziphelp-%:
	$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziphelp-$*

ziponly-%:
	$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziponlyhelp-$*

zipdata-%:
	@$(ECHO) "  zipping data"
	@(cd $(RLIB)/$*/data; \
	  if test -f Rdata.zip ; then \
	    unzip -qou Rdata; \
	  fi; \
	  $(RM) Rdata.zip filelist ; \
	  ls -1 > filelist; \
	  zip -rmq9X Rdata * -x filelist 00Index)

data-%:
	@$(ECHO) "  not zipping data"


#                          ===== cleaning ======

clean: cleanwin $(PKGCLEAN)
	$(RM) -f ../*/*.o $(WINOBJS) *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	-$(MAKE) --no-print-directory -C ../../doc/manual -f Makefile.win distclean
	-$(MAKE) --no-print-directory -C ../nmath/standalone -f Makefile.win distclean
	-$(MAKE) --no-print-directory -C ../modules -f Makefile.win clean
	-$(MAKE) --no-print-directory -C ../../tests -f Makefile.win clean
	$(RM) -f ../library/methods/all.R
	for p in $(R_PKGS_RECOMMENDED); do \
	  $(RM) -rf ../library/$$p; \
	done

distclean veryclean: clean clean-recommended
	$(RM) -r ../../bin ../../lib ../../library ../../modules
	$(RM) ../include/config.h ../include/psignal.h \
	../include/Rconfig.h ../include/Rversion.h ../include/Rmath.h
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.d ../library/*/src/Makedeps
	$(RM) ../library/*/src/*.dll
	$(RM) -r ../library/*/check
	$(RM) ../library/tcltk/src/tcl$(TCL_VERSION).def \
	../library/tcltk//src/tk$(TCL_VERSION).def
	$(RM) R.exp Rm.exp COPYRIGHTS
	$(RM) ../../doc/html/search/index.txt ../../doc/html/index.html \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/search/SearchEngine.html
	$(RM) ../../etc/Rconsole ../../etc/Rdevga ../../etc/Rprofile \
	../../etc/rgb.txt ../../share/make/wintests.mk \
	../include/Platform.h ../../tests/*.Rout ../../tests/*.Rout.fail
	$(MAKE) -C fixed distclean
	-$(MAKE) -C installer distclean
	@for pkg in $(R_PKGS_BASE); do \
	  $(RM) ../library/$${pkg}/DESCRIPTION; \
	done
	$(RM) rw-FAQ fixed/html/rw-FAQ.html
	$(RM) -r cran/index.html cran/ReadMe cran/README* cran/*.exe cran/md5sum.txt \
	  cran/mini
	$(RM) Rpwd.exe # do this last of all

cleanwin:
	$(RM) *.o *.dll *.a *~ \#*\# rw*.zip R.def R.exp1 Rm.exp1\
	   .RData .Rhistory Makedeps *.d
	$(MAKE) -C graphapp clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C help clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../extra/xdr -f Makefile.win clean
	$(MAKE) -C ../extra/pcre -f Makefile.win distclean
	$(MAKE) -C ../extra/bzip2 -f Makefile.win clean
	$(MAKE) -C bitmap clean
	-$(MAKE) -C installer clean


#                          ===== testing ======

# tests
check test: pkgtests test-Basic

test-Basic:
	-@$(MAKE) --no-print-directory -C $(RHOME)/tests -f Makefile.win clean
	-@$(MAKE) --no-print-directory -C $(RHOME)/tests -f Makefile.win

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

all: profiles fixh fixhtml fixbin fixetc fixshare

profiles: ../../../library/base/R/Rprofile

../../../library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.windows
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p ../../../library/base/R
	@$(CAT)  $^ > $@


version: ../../include/Rversion.h
fixh: version h/config.h \
  ../../include/Rconfig.h  ../../include/Rmath.h
	@$(CP) -p ./h/config.h ./h/psignal.h ../../include
	@$(ECHO) done > fixh

../../include/Rconfig.h: h/config.h
	$(SED) -e 1d ../../../tools/GETCONFIG > GC
	(cd h; sh ../GC > ../../../include/Rconfig.h)
	$(RM) GC

../../include/Rversion.h: ../../../date-stamp ../../../VERSION
	$(SED) -e 1d ../../../tools/GETVERSION > ../../../tools/GV
	sh ../../../tools/GV > $@
	$(RM) ../../../tools/GV

../../include/Rmath.h: ../../include/Rmath.h0.in
	$(SED) -e 's/@RMATH_HAVE_LOG1P@/# define HAVE_LOG1P 1/'  -e /@RMATH_HAVE_EXPM1@/d  -e  's/@RMATH_HAVE_WORKING_LOG1P@/# define HAVE_WORKING_LOG1P 1/' $< > $@

../../../bin/massage-Examples: ../../../share/perl/massage-Examples.pl
	$(SED) -e 's/"contr.poly")/"contr.poly"), pager="console"/' $< > $@

../../../bin/check: ../../scripts/check.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" -e "s/Rd2dvi /Rd2dvi.sh /" $< > $@

../../../bin/build: ../../scripts/build.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Sd2Rd: ../../scripts/Sd2Rd.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdconv: ../../scripts/Rdconv.in
	$(SED) -e 1d -e s/\"unix\"/\"windows\"/ -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdiff.sh: ../../scripts/Rdiff
	$(SED) -e 1d -e 's/\$${EGREP}/grep -E/' $< > $@

../../../bin/Rprof: ../../scripts/Rprof.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

fixbin: ../../../bin/massage-Examples ../../../bin/build \
	   ../../../bin/check ../../../bin/Rdconv \
	   ../../../bin/Sd2Rd ../../../bin/Rdiff.sh ../../../bin/Rprof cp2bin
	@$(ECHO) done > fixbin

cp2bin: $(filter-out ./bin/CVS, $(wildcard ./bin/*))
	@zip -q bins $^
	@unzip -oaq bins -d  ../../..
	@$(RM) bins.zip

fixhtml: $(wildcard ./html/*.html) ../../../doc/html/search/SearchEngine.html
	$(CP) -p ./html/*.html ../../../doc/html
	$(CP) -p ./html/rwin.html ../../../doc/html/index.html
	@$(ECHO) done > fixhtml

fixetc: $(filter-out ./etc/CVS, $(wildcard ./etc/*))
	$(CP) -p $^ ../../../etc
	@$(ECHO) done > fixetc

fixshare: ./share/tests.mk
	$(MKDIR) -p ../../../share/make
	$(CP) -p $^ ../../../share/make/wintests.mk
	@$(ECHO) done > fixshare	

clean:
	$(RM) *~ */*~ fixhtml fixh fixbin fixetc fixshare

distclean: clean
	$(RM) -f ../../../tools/GV

../../../doc/html/search/SearchEngine.html:../../../doc/KEYWORDS.db
	(cd ../../../doc; \
	cat html/search/SearchEngine-head.html > html/search/SearchEngine.html; \
	perl ../tools/keywords2html.pl KEYWORDS.db >> html/search/SearchEngine.html; \
	cat html/search/SearchEngine-foot.html >> html/search/SearchEngine.html)

=== src/gnuwin32/help/Makefile ===
# default target builds indices
DOS=# -dosnames   # for file-name mapping
PERL=R_OSTYPE=windows perl
CAT=cat
CP=cp
RM=rm
MKDIR=mkdir

RHOME=$(shell perl ../pwd.pl ../../..)
PKGDIR=../../library
RLIB=$(RHOME)/library

indices:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} -htmllists

pkg-% help-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} \
	  -txt -html -example -latex $(PKGDIR)/$* $(RLIB)

pkgfake-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} \
	  -latex $(PKGDIR)/$* $(RLIB)

chm-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} \
	  -chm $(PKGDIR)/$* $(RLIB)
# hhc always gives an error code
	@$(MAKE)  --no-print-directory -C $(PKGDIR)/$*/chm \
	  -f $(RHOME)/src/gnuwin32/help/Makefile $*.chm
	@$(MKDIR) -p $(RLIB)/$*/chtml
	@$(CP) $(PKGDIR)/$*/chm/$*.chm $(RLIB)/$*/chtml

winhlp-%: chm-%
	$(MAKE) --no-print-directory -C $(PKGDIR)/$*/chm \
	  -f $(RHOME)/src/gnuwin32/help/Makefile $*.hlp
	$(MKDIR) -p $(RLIB)/$*/winhlp
	$(CP) $(PKGDIR)/$*/chm/$*.cnt $(PKGDIR)/$*/chm/$*.hlp $(RLIB)/$*/winhlp

ziphelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqX  PKG=$* zipit

ziponlyhelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqmX PKG=$* zipit


winhelp-%:
	$(MAKE) --no-print-directory -C $(PKGDIR)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* win

latex-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	-f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* unzipit
	PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} -latex $(PKGDIR)/$*

clean:
	$(RM) -fr *~ *.o *.obj *.dll *.def *.a

# to be run from src/library/pkg/chm

HTM = $(filter-out 00Index.html, $(wildcard *.html))
%.chm: $(HTM) Rchm.css logo.jpg
	@hhc $*.hhp || exit 0

%.hlp: %.rtf logo.bmp
	hcrtf /x $*.hpj

%.rtf: $(HTM)
	perl $(RHOME)/share/perl/hhw-to-rtf.pl $*.hhp

Rchm.css: $(RHOME)/src/gnuwin32/help/Rchm.css
	@$(CP) $^ $@

logo.jpg: $(RHOME)/doc/html/logo.jpg
	@$(CP) $^ $@

logo.bmp: $(RHOME)/src/gnuwin32/help/logo.bmp
	@$(CP) $^ $@

# following are designed to be run from the library/pkg directory:

zipit: help/Rhelp.zip zipup
unzipit:
	-@$(MAKE) --no-print-directory -C latex \
	  -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp

help/Rhelp.zip: $(wildcard ../../src/library/$(PKG)/man/*.Rd \
../../src/library/$(PKG)/man/windows/*.Rd)
	-@if test -d help ; then \
	  $(MAKE) --no-print-directory -C help  \
            -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp; \
	fi
	-@if test -d R-ex ; then \
	  $(MAKE) --no-print-directory -C R-ex \
	    -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rex; \
	fi
	-@if test -d latex ; then \
	  $(MAKE) --no-print-directory -C latex \
	    -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp; \
	fi
	-@$(MAKE) --no-print-directory -C $(RHOME)/src/gnuwin32/help help-$(PKG)
	@$(RM) -f help/Rhelp.zip latex/Rhelp.zip R-ex/Rex.zip

zipup:
	@zip -${ZIPFLAGS} help/Rhelp help/* -x help/AnIndex 2> /dev/null || exit 0
	@zip -${ZIPFLAGS} R-ex/Rex R-ex/*.R 2> /dev/null || exit 0
	@zip -${ZIPFLAGS} latex/Rhelp latex/*.tex 2> /dev/null || exit 0

uz-%:
	@if test -f $*.zip ; then \
	  unzip -qou $*; \
	fi

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installers

include ../MkRules
include ../../../share/make/vars.mk

RPREFIX = $(shell perl ../fixed/rwver.pl ../../../VERSION)
LIBFILES = $(foreach i, $(R_PKGS_BASE), ../../../library/$i) ../../../library/R.css

all: $(RPREFIX).exe

#taken from ../include/Makefile.in
SRC_HEADERS = R.h S.h Rdefines.h Rdevices.h Rgraphics.h Rinternals.h Rmath.h
OBJ_HEADERS = Rconfig.h Rversion.h
GW32_HEADERS =

imagedir:
	$(RM) -r $(RPREFIX)
	$(MKDIR) $(RPREFIX)
#
# the next lines were formerly the bindist target
#
	$(CP) -pr ../../../bin ../../../modules ../../../afm $(RPREFIX)
	$(MKDIR) -p $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
# morley.tab is needed for R-intro Appendix A
	$(CP) -p ../../library/base/data/morley.tab $(RPREFIX)/library/base/data
	$(RM) $(RPREFIX)/*/Makefile.in
	(cd $(RPREFIX)/bin; $(RM) INSTALL REMOVE SHLIB build check \
	   massage-Examples Rd2dvi.sh Rd2txt Rdconv Rdiff.sh Sd2Rd)
	$(MKDIR) -p $(RPREFIX)/etc
	$(CP) -p ../../../etc/Rprofile $(RPREFIX)/etc/Rprofile
	$(CP) -p ../../../etc/Rconsole $(RPREFIX)/etc/Rconsole
	$(CP) -p ../../../etc/Rdevga $(RPREFIX)/etc/Rdevga
	$(CP) -p ../../../etc/rgb.txt $(RPREFIX)/etc/rgb.txt
	$(MKDIR) -p $(RPREFIX)/doc/manual  $(RPREFIX)/share/texmf
	$(CP) -pr ../../../doc/html $(RPREFIX)/doc
	$(CP) -p ../../../doc/manual/*.html $(RPREFIX)/doc/manual
	$(CP) -pr ../../../share/texmf $(RPREFIX)/share
	$(CP) -p ../../../AUTHORS ../../../COPYING ../COPYRIGHTS ../../../FAQ ../../../NEWS \
		../../../README ../../../RESOURCES ../../../THANKS ../../../Y2K $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g ../readme > $(RPREFIX)/README.$(RPREFIX)
	$(CP) -p ../rw-faq $(RPREFIX)/rw-FAQ
	$(CP) -p ../CHANGES ../README.Rterm $(RPREFIX)
# convert docs and batch files to CRLF: might already be on Windows, though.
ifeq ($(strip $(BUILD)),CROSS)
	zip -l dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -ao dosfiles.zip
else
	zip dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -o dosfiles.zip
endif
	$(RM) dosfiles.zip
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.html
#
# the next lines were formerly the docsdist target
#
	$(MKDIR) -p $(RPREFIX)/doc/manual
	$(CP) -pr ../../../doc/manual/*.pdf $(RPREFIX)/doc/manual
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.pdf
#
# the next lines were formerly the packagedist target
#
	$(MKDIR) -p $(RPREFIX)/bin $(RPREFIX)/etc \
	  $(RPREFIX)/doc $(RPREFIX)/doc/html $(RPREFIX)/share \
	  $(RPREFIX)/src/include $(RPREFIX)/src/library \
	  $(RPREFIX)/src/gnuwin32/fixed
	$(CP) ../../../doc/html/logo.jpg $(RPREFIX)/doc/html
	$(CP) ../../../doc/KEYWORDS* $(RPREFIX)/doc
	$(CP) -p ../exported-vars ../R.exp ../Rblas.def ../MkRules ../MakePkg ../MakeDll \
	  ../Rpwd.exe ../pwd.pl ../makeDllRes.pl ../install-save.sh $(RPREFIX)/src/gnuwin32
	$(SED) -e s/@RVER@/$(RVER)/g ../Makefile.packages > $(RPREFIX)/src/gnuwin32/Makefile
	$(CP) ../fixed/dobundle.pl $(RPREFIX)/src/gnuwin32/fixed
	$(CP) -pr ../help ../check $(RPREFIX)/src/gnuwin32
	$(RM) $(RPREFIX)/src/gnuwin32/help/*.c \
	  $(RPREFIX)/src/gnuwin32/help/MkChmDll
	(cd ..; $(MAKE) --no-print-directory -C installer/$(RPREFIX)/src/gnuwin32/help clean)
	$(CP) -p $(foreach i,$(SRC_HEADERS) $(OBJ_HEADERS) $(GW32_HEADERS), \
	  ../../include/$i) $(RPREFIX)/src/include
	$(CP) -pr ../../include/R_ext $(RPREFIX)/src/include
	$(SED) -e 3,5d ../readme.packages > $(RPREFIX)/readme.packages
	$(CP) ../../../COPYING.LIB $(RPREFIX)
	$(CP) -r ../../../share/make ../../../share/perl ../../../share/texmf \
	   $(RPREFIX)/share
	$(CP) ../../../bin/INSTALL ../../../bin/REMOVE ../../../bin/SHLIB \
	  ../../../bin/build ../../../bin/check ../../../bin/massage-Examples \
	  ../../../bin/Rd2dvi.sh ../../../bin/Rd2txt ../../../bin/Rdconv \
	  ../../../bin/Rdiff.sh ../../../bin/Sd2Rd  \
          $(RPREFIX)/bin
	$(CP) -pr ../../../lib $(RPREFIX)
	$(CP) ../../../share/make/wintests.mk $(RPREFIX)/share/make
	$(CP) -pr ../../../share/R $(RPREFIX)/share
	$(CP) -p ../graphapp/graphapp.h ../graphapp/ga.h $(RPREFIX)/src/include
	(cd ..; $(MAKE) --no-print-directory PKGDIR=. pkgclean-windlgs)
	$(CP) -pr ../windlgs $(RPREFIX)/src/library
#
# the next lines were formerly the dist-recommended target
#
	@for p in $(R_PKGS_RECOMMENDED); do \
	echo Copying $$p ; \
	$(MKDIR) -p $(RPREFIX)/library/$$p ; \
	$(CP) -pr ../../../library/$$p $(RPREFIX)/library ; \
	done	
#
	find $(RPREFIX) -name CVS -prune -exec rm -rf \{\} \;

R.iss Rsmall.iss: JRins.pl imagedir
	rm -rf $(RPREFIX)/library/*/man
	$(CAT) $(RPREFIX)/library/*/CONTENTS >  \
	  $(RPREFIX)/doc/html/search/index.txt
	echo "make.packages.html(.Library)" | $(RPREFIX)/bin/rterm --vanilla --slave
	$(CP) -pr ../../../Tcl $(RPREFIX)
	perl JRins.pl $(RPREFIX) 

$(RPREFIX).exe: R.iss
	"$(ISDIR)/iscc" R.iss > $(RPREFIX).log
	"$(ISDIR)/iscc" Rsmall.iss > miniR.log

clean:
	rm -rf R.iss Rsmall.iss *.log $(RPREFIX) 

distclean: clean
	rm -f $(RPREFIX).exe miniR*

# for historical reasons
ISclean: clean
ISdistclean: distclean

=== debian/changelog ===
r-base (1.8.0.cvs.20031114-1) unstable; urgency=low

  * Upgraded to the initial 1.8.1 beta release of 2003-11-14

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 14 Nov 2003 19:13:43 -0600

r-base (1.8.0.cvs.20031107-1) unstable; urgency=low

  * Upgraded to the initial 1.8.1 alpha release of 2003-11-07
  * debian/rules: Configure with R_PRINTCMD=/usr/bin/lpr (Closes: #219419)

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  7 Nov 2003 19:56:48 -0600

r-base (1.8.0.cvs.20031101-1) unstable; urgency=low

  * Upgraded to 1.8.0 patched aka pre-1.8.1 as of 2003-11-01
  * Also upgraded R-recommended via rsync
  * debian/rules: make docs has to be called when binary-arch is built 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  1 Nov 2003 18:58:09 -0600

r-base (1.8.0.cvs.20031024-1) unstable; urgency=low

  * Upgraded to 1.8.0 patched as of 2003-10-24
  * Also upgraded R-recommended via rsync
  * To avoid possible upgrade conflicts with pre-releases of 1.8.1, we 
    use previously used ".cvs.YYYYMMDD" naming convention for the package
  * debian/rules: 'make {docs,help,html}' are now called in binary-indep
    which was not possible with earlier versions of R; however as make
    recommended implies make doc, we manually descend into its top dir.

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 23 Oct 2003 15:21:35 -0500

r-base (1.8.0-2) unstable; urgency=low

  * With a big thanks to Camm Maguire for investigating this problem,
    we are reverting back to the previously used setup of defaulting to 
    Blas while automagically switching to Atlas where installed:
    - debian/rules: Patch R.sh.in to disable use of R_LD_LIBRARY_PATH (beyond
      the required $R_HOME/nbin) which conflicts with Debian's transparent 
      switch of Atlas for Blas (as /usr/lib/libblas would be found instead)
    - debian/rules: Configure again with --with-blas=blas
    - debian/control: Hence remove Depends: on atlas2-base-dev | atlas2-dev
    - debian/shlibs.local: Remove, no longer needed
    - debian/rules: No longer need to postprocess Depends
    - debian/rules: Other small cleanups

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 16 Oct 2003 20:13:32 -0500

r-base (1.8.0-1) unstable; urgency=low

  * Upgraded to version 1.8.0 released today

 -- Dirk Eddelbuettel <edd@debian.org>  Wed,  8 Oct 2003 10:10:41 -0500

r-base (1.7.1.cvs.20031004-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0beta_2003-10-04 of R 1.8.0
  * debian/control: Change Depends: to atlas2-base-dev | atlas2-dev 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  4 Oct 2003 07:39:13 -0500

r-base (1.7.1.cvs.20030927-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0beta_2003-09-27 of R 1.8.0
  * debian/control: Add Depends: on atlas2-dev for r-base-dev

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 27 Sep 2003 15:58:45 -0500

r-base (1.7.1.cvs.20030920-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0alpha_2003-09-20 of R 1.8.0
  * debian/{r-base-core,r-gnome}.menu: Small beautifications

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 20 Sep 2003 08:02:54 -0500

r-base (1.7.1.cvs.20030913-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0alpha_2003-09-13 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 13 Sep 2003 09:59:45 -0500

r-base (1.7.1.cvs.20030906-1) unstable; urgency=low

  * Upgraded to release candidate 2003-09-06 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  6 Sep 2003 15:21:02 -0500

r-base (1.7.1.cvs.20030830-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-30 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 30 Aug 2003 09:56:10 -0500

r-base (1.7.1.cvs.20030822-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-22 of R 1.8.0
  * debian/control: Standards-Version increased to 3.6.1.0

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 22 Aug 2003 20:25:52 -0500

r-base (1.7.1.cvs.20030814-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-14 of R 1.7.2 (or 1.8.0)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 14 Aug 2003 20:39:05 -0500

r-base (1.7.1.cvs.20030808-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-08 of R 1.7.2 (or 1.8.0)
  * Upstream release candidate sources do not contain the source for the
    r-recommended package so tools/rsync-recommended was used to obtain
    these and a new, Debian-only, orig.tar.gz of both was created
  * debian/control: r-base-dev now has a versioned Depends on r-base-core
    which requires equal version numbers between the two (Closes: #199295)
  * debian/control: Upgraded Standards-Version to 3.6.0

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  8 Aug 2003 20:08:49 -0500

r-base (1.7.1-1) unstable; urgency=low

  * New upstream version 1.7.1 released today

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 16 Jun 2003 19:36:45 -0500

r-base (1.7.0.cvs.20030607-1) unstable; urgency=low

  * Upgraded to initial release candidate (dated 2003-06-07) of R 1.7.1
  * debian/{control,rules}: Switch back to default compiler version as 3.3 
    is in unstable and testing; m68k still needs f2c for Fortan code

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  7 Jun 2003 12:23:59 -0500

r-base (1.7.0.cvs.20030602-1) unstable; urgency=low

  * Upgraded to initial release candidate (dated 2003-06-02) of R 1.7.1
  * debian/{rules,control}: Try f2c on m68k as a last resort

 -- Dirk Eddelbuettel <edd@debian.org>  Mon,  2 Jun 2003 21:31:42 -0500

r-base (1.7.0.cvs.20030526-1) unstable; urgency=low

  * Upgraded to release candidate 2003-05-26 of R 1.7.1
  * Manually rsync'ed r-recommendeds sources as R-patched pre-release do
    not comprise r-recommended, also manually re-built upstream tarball
  * debian/control: Require gcc/g++/g77-3.2 as version 3.3 is in unstable
    gcc 3.2 works fine everywhere with the exception of m68k (Closes: #194175)
  * debian/shlibs.local: Have libatlas imply either the actual atlas2-base 


=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Uploaders: Douglas Bates <bates@stat.wisc.edu>
Standards-Version: 3.6.1.0
Build-Depends: blas-dev (>= 1.0-9), lapack-dev, libgnome-dev, libzvt-dev, libgtkxmhtml-dev, tcl8.4-dev, tk8.4-dev, libglade-gnome0-dev, bison, g77 [!m68k], f2c [m68k], g++, groff-base, libncurses5-dev, libreadline4-dev, debhelper (>= 3.0.0), texi2html, texinfo (>= 4.1-2), libbz2-dev, libpcre3-dev, libpaperg-dev, tetex-bin, tetex-extra, xpdf-reader

Package: r-base
Architecture: all
Depends: r-base-core, r-base-html, r-base-latex
Suggests: libpaperg, ess, r-doc-info | r-doc-pdf | r-doc-html
Description: GNU R statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This packages is a meta-package which eases the transition from the 
 pre-1.5.0 package setup with its larger r-base package. Once installed, it 
 can be safely removed and apt-get will automatically upgrade its components
 during future upgrades.  Providing this packages gives a way to users to 
 then only install r-base-core (but not, say, r-base-latex) if they so desire.

Package: r-base-core
Architecture: any
Depends: ${perl:Depends}, zlib-bin, ${shlibs:Depends}
Replaces: r-base (<= 1.4.1-1)
Recommends: r-recommended, r-base-dev
Suggests: libpaperg, ess, r-doc-info | r-doc-pdf | r-doc-html
Description: GNU R core of statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This package provides the core GNU R system from which only the optional
 documentation packages r-base-html, r-base-latex, r-doc-html, r-doc-pdf 
 and r-doc-info have been split off to somewhat reduce the size of this 
 package. 

Package: r-gnome
Section: gnome
Architecture: any
Depends: r-base-core (= ${Source-Version}), ${shlibs:Depends}
Recommends: r-cran-gtkdevice
Description: GNU R Gnome gui for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This package provides the dynamic link libraries needed to start GNU R
 with the GNOME libraries frontend as in "R --gui=GNOME"

Package: r-base-dev
Architecture: all
Section: devel
Depends: r-base-core (= ${Source-Version}), blas-dev (>= 1.0-9), build-essential, g77 | f2c, gcc, g++, libncurses5-dev, libreadline4-dev, lapack-dev
Description: GNU R installation of auxiliary GNU R packages 
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages ensures that other Debian packages needed for installation of
 some auxiliary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: r-base-core, r-base-dev
Description: GNU R standalone mathematics library
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

Package: r-base-html
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1)
Suggests: r-doc-html, mozilla | www-browser
Description: GNU R html docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides html documentation suitable for browsing with a 
 web-browser for the libraries included in the r-base package. It is not 
 a required package as the same documentation is already included for 
 on-line browsing. 

Package: r-base-latex
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1)
Description: GNU R LaTeX docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides latex documentation suitable for off-line printing
 for the libraries included in the r-base package. It is not a required 
 package as the same documentation is already included for on-line browsing.

Package: r-doc-pdf
Architecture: all
Section: doc
Suggests: r-base-core, xpdf-reader | pdf-viewer
Description: GNU R pdf manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in pdf format. The sibling packages
 r-doc-html and r-doc-info provides the same manuals.

Package: r-doc-html
Architecture: all
Section: doc
Suggests: r-base-core, mozilla | www-browser
Replaces: r-base (<= 1.4.1-1)
Description: GNU R html manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in html format. The sibling packages
 r-doc-pdf and r-doc-info provides the same manuals.

Package: r-doc-info
Architecture: all
Section: doc
Replaces: r-base (<= 1.4.1-1)
Suggests: r-base-core, info (>= 3.12) | info-browser
Description: GNU R info manuals statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in info format. The sibling packages
 r-doc-html and r-doc-pdf provide the same manuals.

Package: r-recommended
Architecture: any
Depends: r-base-core (= ${Source-Version}), ${shlibs:Depends}
Description: GNU R collection of recommended packages 
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 This Debian package contains the R packages that are recommended by the
 upstream R core team as part of a complete R distribution, and distributed
 along with the source of R itself. The package comprises 
 the following packages:

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2003 by Douglas Bates <bates@stat.wisc.edu> 
#                    and Dirk Eddelbuettel <edd@debian.org>

# $Id: rules,v 1.54.2.1 2003/11/20 15:24:37 bates Exp $

corepackage	= r-base-core
latexpackage	= r-base-latex
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
gnomepackage	= r-gnome
nmathpackage	= r-mathlib
infopackage	= r-doc-info
recdpackage	= r-recommended

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/tmp
debdoc		:= $(debbase)/$(corepackage)/usr/share/doc/$(corepackage)
debmat		:= $(debbase)/$(nmathpackage)
debetc		:= $(debbase)/$(corepackage)/usr/lib/R/etc

arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# set this to 1 (default) if you want the Gnome GUI package
gnome		= 1
ifeq ($(gnome),0)
gnomeconfig 	= --without-gnome
else
gnomeconfig	= --with-gnome
endif

#export DH_VERBOSE = 1
export DH_COMPAT  = 3

# edd 15 Aug 2001  default to blas, atlas can override it 
#atlas 		= --with-blas=blas
# dmb 04 Apr 2003  better to use no specify blas
# atlas 		= --with-blas
# edd 28 Apr 2003  try configuring with atlas
# atlas		= --with-blas=atlas
# edd 16 Oct 2003  back to older default
atlas 		= --with-blas=blas
# edd 08 Mar 2003  use the new lapack feature
# edd 27 Apr 2003  Set this to =no as we currently see numerical errors
lapack		= --with-lapack=no

# edd 02 Sep 2001  default to g77 but let m68k use f2c
# edd 06 Mar 2003  enforce 3.2 versions explicitly 
#                  so that on testing we will pick them over 2.95
# edd 07 Jun 2003  let's fall back to the default compilers
fortrancompiler	= F77=g77
compiler	= gcc
cxxcompiler	= g++
compilerflags	= -O2

# edd 04 Sep 2001  default compiler flags, lowered for m68k
compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
# edd 26 Nov 2002  switched back to g77
# edd 02 Jun 2003  switched back
# cts 04 Jun 2003  use -O1 on m68k
ifeq ($(arch),m68k-linux)
fortrancompiler	= F2C=f2c
compilerflags	= -O1
endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
#ifeq ($(arch),ia64-linux)
#fortrancompiler = F77=g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections  
ifeq ($(arch),hppa-linux)
compilerflags   = -O2 -ffunction-sections
endif

## edd 20 Jun 2002      no optimisation or debugging on baby systems
## edd 02 Jun 2003	use this on arm only 
##ifneq "$(findstring $(arch), m68k-linux arm-linux)" ""
ifneq "$(findstring $(arch), arm-linux)" ""
compilerflags	= -O0 -g0
endif

get-orig-source: upstream
upstream:
	links http://cran.us.r-project.org/src/base

upstreamdevel:
	links ftp://ftp.stat.math.ethz.ch/Software/R
        #links http://cran.us.r-project.org/src/base
        #rsync -vaC rsync.r-project.org::r-devel .

## edd 24 Oct 2003  build is invoked by the buildd, so we would prefer to
##  		    not imply build-indep; unfortunately R does not build
##		    properly without it, so we have to stick with it
#build: build-arch build-indep
build: build-arch

build-arch: make-arch 

build-indep: make-indep 

configure: configure-stamp
configure-stamp:	
	@echo "*** configure ***"

        # we have to disable use of the expanded R_LD_LIBRARY_PATH as it
        # conflicts with Debian's Atlas-can-replace-Blas scheme
        # so set R_LD_LIBRARY_PATH to the minimal value R_HOME/bin
        # and discard what configure finds for it on this machine
	perl -p -i -e 's|:\@R_LD_LIBRARY_PATH\@||' src/scripts/R.sh.in

	dh_testdir
	PERL=/usr/bin/perl				\
	R_UNZIPCMD=/usr/bin/miniunzip			\
	R_ZIPCMD=/usr/bin/minizip			\
	R_PRINTCMD=/usr/bin/lpr				\
	CC=${compiler}					\
	CXX=${cxxcompiler}				\
	${fortrancompiler}				\
	CPPFLAGS=					\
	LDFLAGS=					\
	FLIBS=						\
	./configure --prefix=/usr			\
		    --with-tcltk			\
		    --mandir=/usr/share/man		\
		    --infodir=/usr/share/info		\
		    $(atlas) 				\
		    $(lapack)				\
		    $(gnomeconfig)			\
		    --enable-R-profiling		\
		    --enable-R-shlib			\
		    --with-recommended-packages		\
		    --build $(arch)

#		    --with-tcl-config=/usr/lib/tcl8.3/tclConfig.sh	
#		    --with-tk-config=/usr/lib/tk8.3/tkConfig.sh		

	touch configure-stamp

make-arch: configure make-arch-stamp 
make-arch-stamp: 
	@echo "*** make-arch ***"
	make		CFLAGS="$(compilerflags)"		\
			CXXFLAGS="$(compilerflags)"		\
			FFLAGS="$(compilerflags)"		\
			CC=${compiler} 				\
			CXX=${cxxcompiler}			\
			${fortrancompiler}			\
			R

        # the top-level 'make stamp-recommended' target implies 'make docs'
        # which (for the buildds) implies a lot of time wasted generating 
        # output we already take from the initial i386 build
	make		CFLAGS="$(compilerflags)"		\
			CXXFLAGS="$(compilerflags)"		\
			FFLAGS="$(compilerflags)"		\
			CC=${compiler} 				\
			CXX=${cxxcompiler}			\
			${fortrancompiler}			\
			stamp-recommended

        # make standalone math lib
	(cd src/nmath/standalone; 				\
		make	CFLAGS="$(compilerflags) -D_REENTRANT"	\
			CXXFLAGS="$(compilerflags) -D_REENTRANT"\
			FFLAGS="$(compilerflags) -D_REENTRANT"	\
			CC=${compiler} 				\
			CXX=${cxxcompiler} 			\
			${fortrancompiler}			\
			libRmath_la_LDFLAGS=-Wl,-soname,libRmath.so.$(somaj) \
			)

	touch make-arch-stamp

make-indep: configure make-indep-stamp
make-indep-stamp:
	@echo "*** make-indep ***"
#	make docs
	make html
	make help
	make info
	make pdf
	touch make-indep-stamp

make: make-arch make-indep 

check: make-arch check-stamp
check-stamp: 
	@echo "*** check ***"
ifneq	($(arch),arm-linux)
	-make check
endif
	touch check-stamp

clean:
	@echo "*** clean ***"
	dh_testdir
	dh_testroot
	rm -f 	configure-stamp \
		build-stamp build-indep-stamp build-arch-stamp \
		make-stamp make-arch-stamp make-indep-stamp \
		install-indep-stamp install-arch-stamp \
		check-stamp 
	-make distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html
	-rm -f modules/*.so
        # left over in CVS from r-base --> r-base-core transition
	(cd debian; rm -vf r-base.dirs r-base.files r-base.lintian \
			r-base.menu r-base.postinst)	
	dh_clean

install: install-arch install-indep 

install-arch: make-arch check install-arch-stamp
install-arch-stamp: 
	@echo "*** install-arch ***"
	dh_testdir
	dh_testroot
	dh_clean -a -k
	dh_installdirs -A

	make    	prefix=$(debtmp)/usr   	 		\
			mandir=$(debtmp)/usr/share/man	 	install

        # link $R_HOME/bin/R to real one, and set R_HOME_DIR env.var. 
	(cd $(debtmp)/usr/lib/R/bin/; 					\
		ln -svf ../../../bin/R R;				\
		cd ../../../bin;					\
		perl -p -i -e						\
		    's|^R_HOME_DIR=.*|R_HOME_DIR=/usr/lib/R|' R)

        # set browser to mozilla as mozilla-1.0.0 works with help.start()
	(cd $(debtmp)/usr/lib/R/etc; \
		perl -p -i -e \
			"s|R_BROWSER-'.*'|R_BROWSER-'/usr/bin/mozilla'|" \
			Renviron)

        # fix permissions (Lintian)
	chmod a+x 	$(debtmp)/usr/lib/R/share/sh/echo.sh 		\
			$(debtmp)/usr/lib/R/share/sh/help-links.sh	\
			$(debtmp)/usr/lib/R/share/sh/help-print.sh

        # remove unneeded license files, but link them back
	rm -v 	$(debtmp)/usr/lib/R/COPYING 		\
		$(debtmp)/usr/lib/R/COPYING.LIB 
	(cd $(debtmp)/usr/lib/R/; \
		ln -s ../../share/common-licenses/GPL COPYING; \
		ln -s ../../share/common-licenses/LGPL COPYING.LIB)

        # edd 15 Jul 2002 reduce compile load on small machines
ifneq "$(findstring $(arch), m68k-linux arm-linux)" ""
	perl -p -i -e 's/-g -O2/-g0 -O0/g' $(debtmp)/usr/lib/R/etc/Makeconf
endif

        # edd 10 Jan 2003 fix Perl interpreter path
	(cd $(debtmp)/usr/lib/R/bin; 					\
	    for file in Rdconv Rdindex Rprof Sd2Rd build check; do 	\
		perl -p -i -e "s|/usr/local/bin/perl|/usr/bin/perl|" 	\
		   $${file};						\
	done)
